﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading;
using System.Windows;
using System.Windows.Input;
using System.Windows.Threading;
using EvidenciaUctov.Utils;

namespace EvidenciaUctov
{
	// *************************************************************************
	// *** App *****************************************************************
	// *************************************************************************
	public partial class App : Application
	{
		// ---------------------------------------------------------------------
		public const string Verzia = "1.4";
		public const int VerziaDB = 9;
		// ---------------------------------------------------------------------
		private static readonly List<Cursor> cursors = new List<Cursor>();

		// ---------------------------------------------------------------------
		// --- App Konstruktor -------------------------------------------------
		// ---------------------------------------------------------------------
		public App()
		{
			Thread.CurrentThread.CurrentCulture = Global.DefaultCulture;
			DispatcherUnhandledException += App_DispatcherUnhandledException;
		}

		// ---------------------------------------------------------------------
		// --- App Udalosti ----------------------------------------------------
		// ---------------------------------------------------------------------
		private static void App_DispatcherUnhandledException(object sender, DispatcherUnhandledExceptionEventArgs e)
		{
			try // catch
			{
				// Zobrazime chybu
				e.Handled = true;
				Chyba(e.Exception);
			} // try
			catch (Exception exception)
			{
				Log.Write("Zlyhalo zobrazovanie chýb: " + exception);
			} // catch
		}

		// ---------------------------------------------------------------------
		// --- App Metody ------------------------------------------------------
		// ---------------------------------------------------------------------
		/// <summary>
		/// Waiting
		/// </summary>
		public static void Uzamknut()
		{
			cursors.Add(Mouse.OverrideCursor);
			Mouse.OverrideCursor = Cursors.Wait;
		}

		// ---------------------------------------------------------------------
		public static void Odomknut()
		{
			if (cursors.Count() == 0)
				Mouse.OverrideCursor = Cursors.Arrow;

			Mouse.OverrideCursor = cursors.Last();
			cursors.RemoveAt(cursors.Count() - 1);
		}

		// ---------------------------------------------------------------------
		protected override void OnExit(ExitEventArgs e)
		{
			EvidenciaUctov.Properties.Settings.Default.Save();
		}

		// ---------------------------------------------------------------------
		public static void Chyba(Exception e)
		{
			if (e != null)
				Chyba(e.Message);
		}

		// ---------------------------------------------------------------------
		public static void Chyba(string sprava)
		{
			MessageBox.Show(sprava);	// ??? Pridat vlastny dialog
		}

		// ---------------------------------------------------------------------
		public static void Sprava(string sprava)
		{
			MessageBox.Show(sprava);	// ??? Pridat vlastny dialog
		}
	} // public partial class App

} // namespace EvidenciaUctov