﻿using EvidenciaUctov.Utils;

namespace EvidenciaUctov.DB
{
	// *************************************************************************
	// *** Nastavenia **********************************************************
	// *************************************************************************
	/// <summary>
	/// Online databazove nastavenia
	/// </summary>
	public static class Nastavenia
	{
		// ---------------------------------------------------------------------
		internal const string KeyDBVerzia = "DBVerzia";
		// ---------------------------------------------------------------------
		internal const string VynimkaPrazdnyKluc = "Interná chyba: Kľúč nesmie byť prázdny!";

		// ---------------------------------------------------------------------
		// --- Nastavenia Vlastnosti -------------------------------------------
		// ---------------------------------------------------------------------
		public static int DBVerzia
		{
			get { return DajIntHodnotu(KeyDBVerzia) ?? 0; }
			set { NastavitHodnotu(KeyDBVerzia, value); }
		}

		// ---------------------------------------------------------------------
		// --- Nastavenia Metody -----------------------------------------------
		// ---------------------------------------------------------------------
		private static int? DajIntHodnotu(string kluc)
		{
			string hodnota = Layer.DajHodnotuNastavenia(kluc);
			if (hodnota == null)
				return null;

			return hodnota.ToInt();
		}

		// ---------------------------------------------------------------------
		private static void NastavitHodnotu(string kluc, object hodnota)
		{
			Layer.NastavitHodnotuNastavenia(kluc, hodnota);
		}
	} // public static class Nastavenia

} // namespace EvidenciaUctov.DB