﻿using System.Linq;
using System.Windows;
using System.Windows.Input;

namespace EvidenciaUctov.Dialogy
{
	// *************************************************************************
	// *** FilterVybrat ********************************************************
	// *************************************************************************
	public partial class FilterVybrat : Window
	{
		// ---------------------------------------------------------------------
		// --- FilterVybrat Konstruktor ----------------------------------------
		// ---------------------------------------------------------------------
		public FilterVybrat()
		{
			InitializeComponent();

			this.Inicializovat();
			InicializovatModul();
		}

		// ---------------------------------------------------------------------
		// --- FilterVybrat Vlastnosti -----------------------------------------
		// ---------------------------------------------------------------------
		public DB.SerializovaneData OznaceneData
		{
			get { return ListBoxFilter.SelectedItem as DB.SerializovaneData; }
		}

		// ---------------------------------------------------------------------
		// --- FilterVybrat Udalosti -------------------------------------------
		// ---------------------------------------------------------------------
		private void ListBoxFilter_KeyDown(object sender, KeyEventArgs e)
		{
			switch (e.Key)
			{
				case Key.Delete:
					Vymazat();
					break;

				case Key.Enter:
					Vybrat();
					break;
			} // switch
		}

		// ---------------------------------------------------------------------
		private void ListBoxFilter_MouseDoubleClick(object sender, MouseButtonEventArgs e)
		{
			Vybrat();
		}

		// ---------------------------------------------------------------------
		private void ToolbarFilter_ClickVymazat(object sender, RoutedEventArgs e)
		{
			Vymazat();
		}

		// ---------------------------------------------------------------------
		// --- FilterVybrat Udalosti -------------------------------------------
		// ---------------------------------------------------------------------
		private void InicializovatModul()
		{
			App.Uzamknut();
			try // finally
			{
				// Refresneme zoznam
				ListBoxFilter.ItemsSource = DB.Layer.NacitatData(DB.Layer.TypDat.SerializovanyFilter).OrderBy(item => item.Nazov);
			} // try
			finally
			{
				App.Odomknut();
			} // finallt
		}

		// ---------------------------------------------------------------------
		private void Vymazat()
		{
			if (OznaceneData != null)
			{
				DB.Layer.DataVymazat(OznaceneData.DataId);
				InicializovatModul();
			} // if
		}

		// ---------------------------------------------------------------------
		private void Vybrat()
		{
			DialogResult = true;
		}
	} // public partial class FilterVybrat

} // namespace EvidenciaUctov.Dialogy