﻿using System.Windows;

namespace EvidenciaUctov.Dialogy
{
	// *************************************************************************
	// *** SkupinaFiltraDialog *************************************************
	// *************************************************************************
	public partial class SkupinaFiltraDialog : Window
	{
		// ---------------------------------------------------------------------
		// --- SkupinaFiltraDialog Konstruktor ---------------------------------
		// ---------------------------------------------------------------------
		public SkupinaFiltraDialog()
		{
			InitializeComponent();

			this.Inicializovat(TextBoxNazov);
		}

		// ---------------------------------------------------------------------
		// --- SkupinaFiltraDialog Udalosti ------------------------------------
		// ---------------------------------------------------------------------
		private void ButtonOK_Click(object sender, RoutedEventArgs e)
		{
			DialogResult = true;
		}

		// ---------------------------------------------------------------------
		// --- SkupinaFiltraDialog Metody --------------------------------------
		// ---------------------------------------------------------------------
		protected SkupinaFiltrovMesacnejStatistiky Zapisat()
		{
			return new SkupinaFiltrovMesacnejStatistiky(TextBoxNazov.Text);
		}

		// ---------------------------------------------------------------------
		protected void Nacitat(SkupinaFiltrovMesacnejStatistiky data)
		{
			if (data == null)
				return;

			TextBoxNazov.Text = data.Popis;
		}

		// ---------------------------------------------------------------------
		#region Zobrazenie

		// ---------------------------------------------------------------------
		public static int? NovyZaznam()
		{
			return EditovatZaznam(/*data*/null);
		}

		// ---------------------------------------------------------------------
		public static int? EditovatZaznam(SkupinaFiltrovMesacnejStatistiky data)
		{
			SkupinaFiltraDialog dialog = new SkupinaFiltraDialog();
			dialog.Nacitat(data);

			if (dialog.ShowDialog() ?? false)
			{
				App.Uzamknut();
				try // finally
				{
					// Nacitame hodnoty z dialogu
					data = dialog.Zapisat();

					if (!string.IsNullOrEmpty(data.Popis))
					{
						// Vyskladame data a ulozime
						DB.Layer.SkupinyFiltrovUlozit(data);

						return data.SkupinaFiltrovID;
					} // if
				} // try
				finally
				{
					App.Odomknut();
				} // finally
			} // if

			return null;
		}

		#endregion // Zorbazenie
	} // public partial class SkupinaFiltraDialog

} // namespace EvidenciaUctov.Dialogy