﻿using System.Linq;
using System.Windows;
using System.Windows.Input;

namespace EvidenciaUctov.Dialogy
{
	// *************************************************************************
	// *** SkupinyFitrovDialog *************************************************
	// *************************************************************************
	public partial class SkupinyFitrovDialog : Window
	{
		// ---------------------------------------------------------------------
		// --- SkupinyFitrovDialog Konstruktor ---------------------------------
		// ---------------------------------------------------------------------
		public SkupinyFitrovDialog()
		{
			InitializeComponent();

			this.Inicializovat();
			InicializovatSkupiny();
		}

		// ---------------------------------------------------------------------
		// --- SkupinyFitrovDialog Udalosti ------------------------------------
		// ---------------------------------------------------------------------
		private void ListBoxFilter_KeyDown(object sender, KeyEventArgs e)
		{
			switch (e.Key)
			{
				case Key.Delete:
					VymazatSkupinuFiltra();
					break;

				case Key.Enter:
					EditovatSkupinuFiltra();
					break;
			} // switch
		}

		// ---------------------------------------------------------------------
		private void ListBoxFilter_MouseDoubleClick(object sender, MouseButtonEventArgs e)
		{
			EditovatSkupinuFiltra();
		}

		// ---------------------------------------------------------------------
		private void ToolbarFilter_ClickPridat(object sender, RoutedEventArgs e)
		{
			if (SkupinaFiltraDialog.NovyZaznam().HasValue)
				InicializovatSkupiny();
		}

		// ---------------------------------------------------------------------
		private void ToolbarFilter_ClickEditovat(object sender, RoutedEventArgs e)
		{
			EditovatSkupinuFiltra();
		}

		// ---------------------------------------------------------------------
		private void ToolbarFilter_ClickVymazat(object sender, RoutedEventArgs e)
		{
			VymazatSkupinuFiltra();
		}

		// ---------------------------------------------------------------------
		// --- SkupinyFitrovDialog Metody --------------------------------------
		// ---------------------------------------------------------------------
		private void InicializovatSkupiny()
		{
			App.Uzamknut();
			try // finally
			{
				// Refresneme zoznam
				ListBoxFilter.ItemsSource = DB.Layer.NacitatSkupinyFiltrov().OrderBy(item => item.Popis);
			} // try
			finally
			{
				App.Odomknut();
			} // finallt
		}

		// ---------------------------------------------------------------------
		private void VymazatSkupinuFiltra()
		{
			if (ListBoxFilter.SelectedValue == null)
				return;

			App.Uzamknut();
			try // finally
			{
				// Updatujeme polozku
				DB.Layer.SkupinyFiltrovVymazat(((SkupinaFiltrovMesacnejStatistiky)ListBoxFilter.SelectedValue).SkupinaFiltrovID.Value);

				// Obnovime zoznam
				InicializovatSkupiny();
			} // try
			finally
			{
				App.Odomknut();
			} // finallt
		}

		// ---------------------------------------------------------------------
		private void EditovatSkupinuFiltra()
		{
			if (ListBoxFilter.SelectedValue == null)
				return;

			App.Uzamknut();
			try // finally
			{
				// Updatujeme polozku
				SkupinaFiltraDialog.EditovatZaznam(ListBoxFilter.SelectedValue as SkupinaFiltrovMesacnejStatistiky);

				// Obnovime zoznam
				InicializovatSkupiny();
			} // try
			finally
			{
				App.Odomknut();
			} // finallt
		}
	} // public partial class SkupinyFitrovDialog

} // namespace EvidenciaUctov.Dialogy