﻿using System.Windows;
using System.Linq;
using System;
using EvidenciaUctov.Utils;

namespace EvidenciaUctov.Dialogy
{
	// *************************************************************************
	// *** UcetDialog **********************************************************
	// *************************************************************************
	public partial class UcetDialog : Window
    {
		// ---------------------------------------------------------------------
		// --- UcetDialog Konstruktor ------------------------------------------
		// ---------------------------------------------------------------------
		public UcetDialog()
        {           
			InitializeComponent();
			this.Inicializovat(TextBoxNazov);

			// Naplnime zoznam s bankami
			ComboBoxBanka.ItemsSource = EnumUtils.GetEnumList<Banka>(Banka.Neznama);
        }

		// ---------------------------------------------------------------------
		// --- UcetDialog Udalosti ---------------------------------------------
		// ---------------------------------------------------------------------
		private void ButtonOk_Click(object sender, RoutedEventArgs e)
		{
			Validuj();
			DialogResult = true;
		}

		// ---------------------------------------------------------------------
		// --- UcetDialog Metody -----------------------------------------------
		// ---------------------------------------------------------------------
		public static bool NovyUcet(out int? ucetID)
		{
			ucetID = null;

			UcetDialog dialog = new UcetDialog();
			if (dialog.ShowDialog() ?? false)
			{
				App.Uzamknut();
				try // finally
				{
					// Vyskladame data a ulozime
					Ucet data = new Ucet(dialog.TextBoxNazov.Text, (Banka)dialog.ComboBoxBanka.SelectedValue, dialog.TextBoxCisloUctu.Text);
					DB.Layer.UcetUlozit(data);

					ucetID = data.UcetID;
					return true;
				} // try
				finally
				{
					App.Odomknut();
				} // finally
			} // if

			return false;
		}

		// ---------------------------------------------------------------------
		private void Validuj()
		{
			if (string.IsNullOrEmpty(TextBoxNazov.Text))
			{
				Dispatcher.Focus(TextBoxNazov);
				throw new Exception("Názov nesmie byť prázdny!");
			} // if

			if (ComboBoxBanka.SelectedIndex < 0)
			{
				Dispatcher.Focus(ComboBoxBanka);
				throw new Exception("Musí byť zvolená banka!");
			} // if
		}
	} // public partial class UcetDialog

} // namespace EvidenciaUctov.Dialogy