﻿using System.Windows;
using System.Windows.Input;

namespace EvidenciaUctov.Dialogy
{
	// *************************************************************************
	// *** Utils ***************************************************************
	// *************************************************************************
	public static class Utils
	{
		// ---------------------------------------------------------------------
		public static void Inicializovat(this Window window, UIElement focusControl = null)
		{
			// Aby sa okno nedostalo pod materske okno
			window.Owner = Application.Current.MainWindow;

			// Inicializujeme element
			if (focusControl != null)
			{
				window.Loaded += (sender, e) => FocusManager.SetFocusedElement(window, focusControl);
			} // if

			// Na esc zavrieme dialog
			window.KeyDown += (sender, e) =>
				{
					if (e.Key == Key.Escape)
					{
						window.DialogResult = false;
						e.Handled = true;
					} // if
				};

			// Ak sa vola dialog a kuroz je nejaky int zapamatame si ho a potom vratime
			var aktualnyKurzor = Mouse.OverrideCursor;
			Mouse.OverrideCursor = Cursors.Arrow;
			window.Closed += (sender, e) =>
				{
					Mouse.OverrideCursor = aktualnyKurzor;
				};
		}
	} // public static class Utils

} // namespace EvidenciaUctov.Dialogy