﻿using System.Collections.Generic;
using EvidenciaUctov.Utils;

namespace EvidenciaUctov
{
	// *************************************************************************
	// *** MesacnaStatistika ***************************************************
	// *************************************************************************
	public class MesacnaStatistikaFilter
	{
		// ---------------------------------------------------------------------
		internal int? FilterID;
		public string Popis;
		public bool Ignorovat;
		public int? SkupinaFiltrovID;

		// ---------------------------------------------------------------------
		// --- Ucet Metody -----------------------------------------------------
		// ---------------------------------------------------------------------
		public override string ToString()
		{
			string flagIgnorovat = Ignorovat ? string.Empty : "*";
			return flagIgnorovat.PadRight(1) + " " + Popis;
		}
	} // public struct Filter

	// *************************************************************************
	// *** MesacnaStatistikaFilterPodmienka ************************************
	// *************************************************************************
	public class MesacnaStatistikaFilterPodmienka
	{
		// ---------------------------------------------------------------------
		internal int? FilterPodmienkaID;
		internal int FilterID;
		public string Format;
		public bool JeVydaj = true;	// ??? Neimplementovane
		public DruhObratu DruhObratu;

		// ---------------------------------------------------------------------
		// --- MesacnaStatistikaFilterPodmienka Konstruktor --------------------
		// ---------------------------------------------------------------------
		public MesacnaStatistikaFilterPodmienka(string format, int filterID, DruhObratu druhObratu)
		{
			Format = format;
			FilterID = filterID;
			DruhObratu = druhObratu;
		}

		// ---------------------------------------------------------------------
		// --- MesacnaStatistikaFilterPodmienka Metody -------------------------
		// ---------------------------------------------------------------------
		public override string ToString()
		{
			return new List<string>() { Format, DruhObratu.ToString() + " obraty" }.ToDelimitedString();
		}
	} // public struct FilterPodmienka

	// *************************************************************************
	// *** SkupinaFiltrovMesacnejStatistiky ************************************
	// *************************************************************************
	public class SkupinaFiltrovMesacnejStatistiky
	{
		// ---------------------------------------------------------------------
		internal int? SkupinaFiltrovID;
		public string Popis;

		// ---------------------------------------------------------------------
		// --- SkupinaFiltrovMesacnejStatistiky Konstruktor --------------------
		// ---------------------------------------------------------------------
		public SkupinaFiltrovMesacnejStatistiky(string popis)
		{
			Popis = popis;
		}

		// ---------------------------------------------------------------------
		// --- SkupinaFiltrovMesacnejStatistiky Metody -------------------------
		// ---------------------------------------------------------------------
		public override string ToString()
		{
			return Popis;
		}
	} // public struct SkupinaFiltrov

} // namespace EvidenciaUctov