﻿using System;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Controls;
using EvidenciaUctov.Utils;

namespace EvidenciaUctov.Submoduly
{
	// *************************************************************************
	// *** FilterControl *******************************************************
	// *************************************************************************
	public partial class FilterControl : UserControl
	{
		// ---------------------------------------------------------------------
		private readonly List<CheckBox> checkboxyMesiacov;
		private bool checkboxyMesiacovUzamknute = false;

		// ---------------------------------------------------------------------
		// --- FilterControl Konstruktor ---------------------------------------
		// ---------------------------------------------------------------------
		public FilterControl()
		{
			InitializeComponent();
			
			checkboxyMesiacov = new List<CheckBox>()
			{
				CheckBoxJanuar, CheckBoxFebruar, CheckBoxMarec, CheckBoxApril, CheckBoxMaj, CheckBoxJun,
				CheckBoxJul, CheckBoxAugust, CheckBoxSeptember, CheckBoxOktober, CheckBoxNovember, CheckBoxDecember
			};

			Inicializovat();
		}

		// ---------------------------------------------------------------------
		// --- FilterControl Udalosti ------------------------------------------
		// ---------------------------------------------------------------------
		private void CheckBoxVsetkyMesiace_Click(object sender, RoutedEventArgs e)
		{
			if (!checkboxyMesiacovUzamknute)
				ChecknutMesiace((sender as CheckBox).IsChecked ?? false);
		}

		// ---------------------------------------------------------------------
		private void CheckBoxMesiac_Click(object sender, RoutedEventArgs e)
		{
			checkboxyMesiacovUzamknute = true;
			try // finally
			{
				bool hodnota = (sender as CheckBox).IsChecked ?? false;
				if (!hodnota)
					CheckBoxVsetkyMesiace.IsChecked = false;
				else
				{
					// Zistime ci su vsetky mesiace
					CheckBoxVsetkyMesiace.IsChecked = (checkboxyMesiacov.FindAll(item => item.IsChecked ?? false).Count == 12);
				} // else
			} // try
			finally
			{
				checkboxyMesiacovUzamknute = false;
			} // finllay
		}

		// ---------------------------------------------------------------------
		// --- FilterControl Metody --------------------------------------------
		// ---------------------------------------------------------------------
		public FilterObdobie DajFilter()
		{
			if (!string.IsNullOrEmpty(TextBoxRok.Text) && !TextBoxRok.Text.IsInt())
			{
				Dispatcher.Focus(TextBoxRok);
				throw new Exception("Chybný rok!");
			} // if

			var mesiace = new List<int>();
			for (int indexMesiaca = 0; indexMesiaca < 12; indexMesiaca++)
			{
				if (checkboxyMesiacov[indexMesiaca].IsChecked ?? false)
					mesiace.Add(indexMesiaca + 1);
			} // for

			return new FilterObdobie() { Rok = TextBoxRok.Text.ToInt(), Mesiace = mesiace.ToArray() };
		}

		// ---------------------------------------------------------------------
		private void ChecknutMesiace(bool hodnota)
		{
			checkboxyMesiacov.ForEach(item => item.IsChecked = hodnota);
		}

		// ---------------------------------------------------------------------
		private void Inicializovat()
		{
			TextBoxRok.Text = DateTime.Now.Year.ToString();
			CheckBoxVsetkyMesiace.IsChecked = true;
			ChecknutMesiace(/*hodnota*/true);
		}
	} // public partial class FilterControl

} // namespace EvidenciaUctov.Submoduly