﻿using System.Windows;
using System.Windows.Controls;
using EvidenciaUctov.Utils;

namespace EvidenciaUctov.Submoduly
{
	// *************************************************************************
	// *** ToolbarMainControl **************************************************
	// *************************************************************************
	public partial class ToolbarMainControl : UserControl
	{
		// ---------------------------------------------------------------------
		private event RoutedEventHandler clickPridatUcet;
		private event RoutedEventHandler clickRefresh;
		private event RoutedEventHandler clickIgnorovat;
		private event RoutedEventHandler clickVymazat;
		private event RoutedEventHandler clickImportovat;
		private event RoutedEventHandler clickHladat;

		// ---------------------------------------------------------------------
		// --- ToolbarMainControl Konstruktor ----------------------------------
		// ---------------------------------------------------------------------
		public ToolbarMainControl()
		{
			InitializeComponent();
			AktivovatTlacidla();
		}

		// ---------------------------------------------------------------------
		// --- ToolbarMainControl Event Handlers -------------------------------
		// ---------------------------------------------------------------------
		public event RoutedEventHandler ClickPridatUcet
		{
			add
			{
				clickPridatUcet += value;
				AktivovatTlacidla();
			} // add

			remove
			{
				clickPridatUcet -= value;
				AktivovatTlacidla();
			} // remove
		}

		// ---------------------------------------------------------------------
		public event RoutedEventHandler ClickRefresh
		{
			add
			{
				clickRefresh += value;
				AktivovatTlacidla();
			} // add

			remove
			{
				clickRefresh -= value;
				AktivovatTlacidla();
			} // remove
		}

		// ---------------------------------------------------------------------
		public event RoutedEventHandler ClickIgnorovat
		{
			add
			{
				clickIgnorovat += value;
				AktivovatTlacidla();
			} // add

			remove
			{
				clickIgnorovat -= value;
				AktivovatTlacidla();
			} // remove
		}

		// ---------------------------------------------------------------------
		public event RoutedEventHandler ClickVymazat
		{
			add
			{
				clickVymazat += value;
				AktivovatTlacidla();
			} // add

			remove
			{
				clickVymazat -= value;
				AktivovatTlacidla();
			} // remove
		}

		// ---------------------------------------------------------------------
		public event RoutedEventHandler ClickImportovat
		{
			add
			{
				clickImportovat += value;
				AktivovatTlacidla();
			} // add

			remove
			{
				clickImportovat -= value;
				AktivovatTlacidla();
			} // remove
		}

		// ---------------------------------------------------------------------
		public event RoutedEventHandler ClickHladat
		{
			add
			{
				clickHladat += value;
				AktivovatTlacidla();
			} // add

			remove
			{
				clickHladat -= value;
				AktivovatTlacidla();
			} // remove
		}

		// ---------------------------------------------------------------------
		// --- ToolbarMainControl Methods --------------------------------------
		// ---------------------------------------------------------------------
		private void Button_IsEnabledChanged(object sender, DependencyPropertyChangedEventArgs e)
		{
			(sender as Button).ButtonIsEnabledChanged();
		}

		// ---------------------------------------------------------------------
		private void ButtonPridatUcet_Click(object sender, RoutedEventArgs e)
		{
			if (clickPridatUcet != null)
				clickPridatUcet(sender, e);
		}

		// ---------------------------------------------------------------------
		private void ButtonRefresh_Click(object sender, RoutedEventArgs e)
		{
			if (clickRefresh != null)
				clickRefresh(sender, e);
		}

		// ---------------------------------------------------------------------
		private void ButtonIgnorovat_Click(object sender, RoutedEventArgs e)
		{
			if (clickIgnorovat != null)
				clickIgnorovat(sender, e);
		}

		// ---------------------------------------------------------------------
		private void ButtonVymazat_Click(object sender, RoutedEventArgs e)
		{
			if (clickVymazat != null)
				clickVymazat(sender, e);
		}

		// ---------------------------------------------------------------------
		private void ButtonImportovat_Click(object sender, RoutedEventArgs e)
		{
			if (clickImportovat != null)
				clickImportovat(sender, e);
		}

		// ---------------------------------------------------------------------
		private void ButtonHladat_Click(object sender, RoutedEventArgs e)
		{
			if (clickHladat != null)
				clickHladat(sender, e);
		}

		// ---------------------------------------------------------------------
		// --- ToolbarMainControl Methods --------------------------------------
		// ---------------------------------------------------------------------
		private void AktivovatTlacidla()
		{
			if (!System.ComponentModel.DesignerProperties.GetIsInDesignMode(/*element*/this))
			{
				ButtonPridatUcet.Visibility = (clickPridatUcet != null).ToVisibility();
				ButtonRefresh.Visibility = (clickRefresh != null).ToVisibility();
				ButtonIgnorovat.Visibility = (clickIgnorovat != null).ToVisibility();
				ButtonVymazat.Visibility = (clickVymazat != null).ToVisibility();
				ButtonImportovat.Visibility = (clickImportovat != null).ToVisibility();
				ButtonHladat.Visibility = (clickHladat != null).ToVisibility();
			} // if
		}
	} // public partial class ToolbarMainControl

} // namespace EvidenciaUctov.Submoduly