﻿using System.Windows;
using System.Windows.Controls;
using EvidenciaUctov.Utils;

namespace EvidenciaUctov.Submoduly
{
	// *************************************************************************
	// *** ToolbarStatistikaMesacna ********************************************
	// *************************************************************************
	public partial class ToolbarStatistikaMesacna : UserControl
	{
		// ---------------------------------------------------------------------
		private event RoutedEventHandler clickRefresh;
		private event RoutedEventHandler clickPrisposobit;

		// ---------------------------------------------------------------------
		// --- ToolbarStatistikaMesacna Konstruktor ----------------------------
		// ---------------------------------------------------------------------
		public ToolbarStatistikaMesacna()
		{
			InitializeComponent();
			AktivovatTlacidla();
		}

		// ---------------------------------------------------------------------
		// --- ToolbarStatistikaMesacna Event Handlers -------------------------
		// ---------------------------------------------------------------------
		public event RoutedEventHandler ClickRefresh
		{
			add
			{
				clickRefresh += value;
				AktivovatTlacidla();
			} // add

			remove
			{
				clickRefresh -= value;
				AktivovatTlacidla();
			} // remove
		}

		// ---------------------------------------------------------------------
		public event RoutedEventHandler ClickPrisposobit
		{
			add
			{
				clickPrisposobit += value;
				AktivovatTlacidla();
			} // add

			remove
			{
				clickPrisposobit -= value;
				AktivovatTlacidla();
			} // remove
		}

		// ---------------------------------------------------------------------
		// --- ToolbarStatistikaMesacna Methods --------------------------------
		// ---------------------------------------------------------------------
		private void Button_IsEnabledChanged(object sender, DependencyPropertyChangedEventArgs e)
		{
			(sender as Button).ButtonIsEnabledChanged();
		}

		// ---------------------------------------------------------------------
		private void ButtonRefresh_Click(object sender, RoutedEventArgs e)
		{
			if (clickRefresh != null)
				clickRefresh(sender, e);
		}

		// ---------------------------------------------------------------------
		private void ButtonPrisposobit_Click(object sender, RoutedEventArgs e)
		{
			if (clickPrisposobit != null)
				clickPrisposobit(sender, e);
		}

		// ---------------------------------------------------------------------
		// --- ToolbarStatistikaMesacna Methods --------------------------------
		// ---------------------------------------------------------------------
		private void AktivovatTlacidla()
		{
			if (!System.ComponentModel.DesignerProperties.GetIsInDesignMode(/*element*/this))
			{
				ButtonRefresh.Visibility = (clickRefresh != null).ToVisibility();
				ButtonPrisposobit.Visibility = (clickPrisposobit != null).ToVisibility();
			} // if
		}
	} // public partial class ToolbarStatistikaMesacna

} // EvidenciaUctov.Submoduly