﻿using System.Windows;
using System.Windows.Controls;
using EvidenciaUctov.Utils;

namespace EvidenciaUctov.Submoduly
{
	// *************************************************************************
	// *** ToolbarStatistikaMesacnaPrisposobit *********************************
	// *************************************************************************
	public partial class ToolbarStatistikaMesacnaPrisposobit : UserControl
	{
		// ---------------------------------------------------------------------
		private event RoutedEventHandler clickPridat;
		private event RoutedEventHandler clickEditovat;
		private event RoutedEventHandler clickVymazat;
		private event RoutedEventHandler clickIgnorovat;

		// ---------------------------------------------------------------------
		// --- ToolbarStatistikaMesacnaPrisposobit Konstruktor -----------------
		// ---------------------------------------------------------------------
		public ToolbarStatistikaMesacnaPrisposobit()
		{
			InitializeComponent();
			AktivovatTlacidla();
		}

		// ---------------------------------------------------------------------
		// --- ToolbarStatistikaMesacnaPrisposobit Event Handlers --------------
		// ---------------------------------------------------------------------
		public event RoutedEventHandler ClickPridat
		{
			add
			{
				clickPridat += value;
				AktivovatTlacidla();
			} // add

			remove
			{
				clickPridat -= value;
				AktivovatTlacidla();
			} // remove
		}

		// ---------------------------------------------------------------------
		public event RoutedEventHandler ClickEditovat
		{
			add
			{
				clickEditovat += value;
				AktivovatTlacidla();
			} // add

			remove
			{
				clickEditovat -= value;
				AktivovatTlacidla();
			} // remove
		}

		// ---------------------------------------------------------------------
		public event RoutedEventHandler ClickVymazat
		{
			add
			{
				clickVymazat += value;
				AktivovatTlacidla();
			} // add

			remove
			{
				clickVymazat -= value;
				AktivovatTlacidla();
			} // remove
		}

		// ---------------------------------------------------------------------
		public event RoutedEventHandler ClickIgnorovat
		{
			add
			{
				clickIgnorovat += value;
				AktivovatTlacidla();
			} // add

			remove
			{
				clickIgnorovat -= value;
				AktivovatTlacidla();
			} // remove
		}

		// ---------------------------------------------------------------------
		// --- ToolbarMainControl Methods --------------------------------------
		// ---------------------------------------------------------------------
		private void Button_IsEnabledChanged(object sender, DependencyPropertyChangedEventArgs e)
		{
			(sender as Button).ButtonIsEnabledChanged();
		}

		// ---------------------------------------------------------------------
		private void ButtonPridat_Click(object sender, RoutedEventArgs e)
		{
			if (clickPridat != null)
				clickPridat(sender, e);
		}

		// ---------------------------------------------------------------------
		private void ButtonEditovat_Click(object sender, RoutedEventArgs e)
		{
			if (clickEditovat != null)
				clickEditovat(sender, e);
		}

		// ---------------------------------------------------------------------
		private void ButtonVymazat_Click(object sender, RoutedEventArgs e)
		{
			if (clickVymazat != null)
				clickVymazat(sender, e);
		}

		// ---------------------------------------------------------------------
		private void ButtonIgnorovat_Click(object sender, RoutedEventArgs e)
		{
			if (clickIgnorovat != null)
				clickIgnorovat(sender, e);
		}

		// ---------------------------------------------------------------------
		// --- ToolbarStatistikaMesacnaPrisposobit Methods ---------------------
		// ---------------------------------------------------------------------
		private void AktivovatTlacidla()
		{
			if (!System.ComponentModel.DesignerProperties.GetIsInDesignMode(/*element*/this))
			{
				ButtonPridat.Visibility = (clickPridat != null).ToVisibility();
				ButtonEditovat.Visibility = (clickEditovat != null).ToVisibility();
				ButtonVymazat.Visibility = (clickVymazat != null).ToVisibility();
				ButtonIgnorovat.Visibility = (clickIgnorovat != null).ToVisibility();
			} // if
		}
	} // public partial class ToolbarStatistikaMesacnaPrisposobit

} // namespace EvidenciaUctov.Submoduly