﻿using System;
using System.IO;
using System.Reflection;

namespace EvidenciaUctov.Utils
{
	// *************************************************************************
	// *** ResourceUtils *******************************************************
	// *************************************************************************
	public static class ResourceUtils
	{
		// ---------------------------------------------------------------------
		public static Assembly GetAssembly(Type assemblyType)
		{
			return Assembly.GetAssembly(assemblyType);
		}

		// ---------------------------------------------------------------------
		public static string GetResourceName(Assembly assembly, string resourceName)
		{
			string[] resources = assembly.GetManifestResourceNames();

			foreach (string resource in resources)
			{
				if (resource == resourceName)
					return resource;
			} // foreach

			foreach (string resource in resources)
			{
				if (resource.EndsWith("." + resourceName))
					return resource;
			} // foreach

			return null;
		}

		// ---------------------------------------------------------------------
		public static Stream GetResource(Type assemblyType, string resourceName)
		{
			Assembly assembly = GetAssembly(assemblyType);
			return GetResource(assembly, resourceName);
		}

		// ---------------------------------------------------------------------
		public static Stream GetResource(Assembly assembly, string resourceName)
		{
			string resource = GetResourceName(assembly, resourceName);
			return resource != null ? assembly.GetManifestResourceStream(resource) : null;
		}
	} // public static class ResourceUtils

} // namespace EvidenciaUctov.Utils