﻿using System;
using System.Xml.Linq;
using System.Xml.Serialization;

namespace EvidenciaUctov.Utils
{
	// *************************************************************************
	// *** XmlUtils ************************************************************
	// *************************************************************************
	public static class XmlUtils
	{
		// ---------------------------------------------------------------------
		public static XDocument Save(object value)
		{
			var document = new XDocument();
			var xmlSerializer = new XmlSerializer(value.GetType());
			using (var xmlWriter = document.CreateWriter())
				xmlSerializer.Serialize(xmlWriter, value);

			return document;
		}

		// ---------------------------------------------------------------------
		public static T Load<T>(string xml)
		{
			return Load<T>(XDocument.Parse(xml));
		}

		// ---------------------------------------------------------------------
		public static T Load<T>(XContainer element)
		{
			try // try
			{
				var xmlSerializer = new XmlSerializer(typeof(T));
				using (var xmlReader = element.CreateReader())
					return (T)xmlSerializer.Deserialize(xmlReader);
			} // try
			catch (Exception e)
			{
				if (e.InnerException != null)
					throw new Exception(e.Message + " [" + e.InnerException.Message + "]", e);

				throw;
			} // catch
		}
	} // public static class XmlUtils

} // namespace EvidenciaUctov.Utils